
### Important note ###

*This document is a draft.* It is currently under legal review.


### Contributing ###

Contributing to zones is easy. In a few simple steps:

  * Ensure that you're not wasting your time by writing a patch that we
    can't accept. When in doubt talk to any of the zone maintainers,
    currently @piscisaureus and @sam-github.

  * Make something better or fix a bug.

  * Adhere to code style outlined in the [Google Javascript Style Guide][].

  * [Sign your patches](#signing-patches) to indicate that your are making your
    contribution available under the terms of the
    [Contributor License Agreement](#contributor-license-agreement).

  * Submit a pull request through Github.


### Signing patches ###

By signing off your patches you show us that you are making your
contribution available under terms of the [Contributor License
Agreement](contributor-license-agreement).

By doing so you are granting StrongLoop, inc. a license that allows us
to publish your contribution under any license. When acceppted we'll
typically make your work available under terms of the project's
[license][], which is currently the Artistic License 2.0.

To sign off a contribution, add the following line to the bottom of the
commit message. Use your real name and an actual e-mail address.

```
Signed-off-by: Random J Developer <random@developer.example.org>
```

Alternatively you can use the git command line to automatically add this line, as follows:

```
$ git commit -sm "Replace rainbows by unicorns"
```


### Contributor License Agreement ###

```
  By making a signed contribution to this project, You certify that:

  * You grant us the ability to use the Contributions in any way.

    You hereby grant to StrongLoop, inc., a non-exclusive, irrevocable,
    worldwide, royalty-free, sublicenseable, transferable license under
    all  of Your relevant intellectual property rights (including
    copyright, patent, and any other rights), to use, copy, prepare
    derivative works  of, distribute and publicly perform and display
    the Contributions on any licensing terms, including without
    limitation:
      (a) open source licenses like the GNU General Public License,
          the Artistic License, or the Berkeley Software Distribution
          license
      (b) binary, proprietary, or commercial licenses.

  * You are able to grant us these rights.

    You represent that You are legally entitled to grant the above
    license. If Your employer has rights to intellectual property that
    You create, You represent that You have received permission to
    make the Contributions on behalf of that employer, or that Your
    employer has waived such rights for the Contributions.

  * The Contributions are your original work.

    You represent that the Contributions are Your original works of
    authorship, and to Your knowledge, no other person claims, or has
    the right to claim, any right in any invention or patent related
    to the Contributions. You also represent that You are not legally
    obligated, whether by entering into an agreement or otherwise, in
    any way that conflicts with the terms of this license. For example,
    if you have signed an agreement requiring you to assign the
    intellectual property rights in the Contributions to an employer
    or customer, that would conflict with the terms of this license.

  * No Implied Warranties.

    StrongLoop, Inc. acknowledges that, except as explicitly described
    in this Agreement, the Contribution is provided on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR
    IMPLIED, INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR
    CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY, OR FITNESS
    FOR A PARTICULAR PURPOSE.

  * Except for the licenses granted herein, You reserve all right,
    title, and interest in and to the Contribution.
```


[Google Javascript Style Guide]: https://google-styleguide.googlecode.com/svn/trunk/javascriptguide.xml
[license]: LICENSE