var Zone = require('../').Zone; // require('zone');

var net = require('net');
var http = require('http');


new Zone(function server_zone() {
  var server = http.createServer(function(req, res) {
    console.log('incoming!');
    res.writeHead(200);
    res.end('Hello!');
  });

  server.listen(3000);
});


for (var i = 0; i < 10; i++)
  makeRequest();

function makeRequest() {
  new Zone(function request_zone() {
    var options = {
      port: 3000,
      path: '/',
      method: 'POST',
      agent: false
    };
    
    console.log('making request');
    var req = http.request(options, function(res) {
      console.log('STATUS: ' + res.statusCode);
      console.log('HEADERS: ' + JSON.stringify(res.headers));
      res.setEncoding('utf8');
      res.on('data', function(chunk) {
        console.log('BODY: ' + chunk);
      });
    });

    req.on('error', function(e) {
      console.log('problem with request: ' + e.message);
    });

    // write data to request body
    req.write('data\n');
    req.end();
  }).setCallback(function(error) {
    if (error)
      console.log(error);

    makeRequest();
  });
}
